//////////////////////////////////////////////////
/////////////////Stereo Anaglyphs/////////////////
//////////////////////////////////////////////////
//////////////////////////////////////////////////
////02.03.2008////////////////by Nils Daumann/////
/////////////slindev.wordpress.com////////////////
//////////////////////////////////////////////////


material StereoComb_mat
{
	effect =
	"
		//Variables set by the engine:
		float4 vecViewPort;
		
		//Textures:
		texture mtlSkin1;
		texture mtlSkin2;
		
		//Sampler:
		sampler smpTarget = sampler_state { Texture = <mtlSkin1>; };
		sampler smpSkin1 = sampler_state { Texture = <mtlSkin2>; };

/////////////////////////////////////////////////////////
//		//Real Anaglyphs
//		float4x4 matView1ColTrans =
//		{
//			0.299,	0.587,	0.114,	0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
//		
//		float4x4 matView2ColTrans =
//		{
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.299,	0.587,	0.114,	0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
/////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////
//		//Grey Anaglyphs:
//		float4x4 matView1ColTrans =
//		{
//			0.299,	0.587,	0.114,	0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
//		
//		float4x4 matView2ColTrans =
//		{
//			0.0,		0.0,		0.0,		0.0,
//			0.299,	0.587,	0.114,	0.0,
//			0.299,	0.587,	0.114,	0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
/////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////
//		//Colored Anaglyphs:
//		float4x4 matView1ColTrans =
//		{
//			1.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
//		
//		float4x4 matView2ColTrans =
//		{
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		1.0,		0.0,		0.0,
//			0.0,		0.0,		1.0,		0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
/////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////
//		//Halfcolored Anaglyphs:
//		float4x4 matView1ColTrans =
//		{
//			0.299,	0.587,	0.114,	0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
//		
//		float4x4 matView2ColTrans =
//		{
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		1.0,		0.0,		0.0,
//			0.0,		0.0,		1.0,		0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
/////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////
		//Optimised Anaglyphs:
		float4x4 matView1ColTrans =
		{
			0.0,		0.7,		0.3,		0.0,
			0.0,		0.0,		0.0,		0.0,
			0.0,		0.0,		0.0,		0.0,
			0.0,		0.0,		0.0,		1.0
		};
		
		float4x4 matView2ColTrans =
		{
			0.0,		0.0,		0.0,		0.0,
			0.0,		1.0,		0.0,		0.0,
			0.0,		0.0,		1.0,		0.0,
			0.0,		0.0,		0.0,		1.0
		};
/////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////
//		//Amber-Blue Anaglyphs:
//		float4x4 matView1ColTrans =
//		{
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.299,	0.587,	0.114,	0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
//		
//		float4x4 matView2ColTrans =
//		{
//			1.0,		0.0,		0.0,		0.0,
//			0.0,		1.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
/////////////////////////////////////////////////////////

		
		float4 PixeShader(float2 TexCoords : TEXCOORD0) :COLOR
		{
			//Get the texturepixels colors
			TexCoords *= float2(1.0,vecViewPort.x/vecViewPort.y);
			float4 ColorView1 = tex2D(smpTarget,TexCoords);
			float4 ColorView2 = tex2D(smpSkin1,TexCoords);
			
			//calculate the resulting color
			float4 Color = mul(matView1ColTrans,ColorView1)+mul(matView2ColTrans,ColorView2);

			return Color;
		}
		
		technique PPE
		{
			pass p1
			{
				PixelShader = compile ps_2_0 PixeShader();
			}
		}
	";
}

//view needed for postprocessing
view PP_Cam{layer = -1;}

//view entity displaying the postprocessed image
entity PP_Quad
{
	type = <PPE_Quad.tga>;
	layer = 0;
	view = PP_Cam;
	
	x = 878;
	y = 0;
	z = 0;

	scale_x = 1.0;
	scale_y = 1.0;
}

//initializes postprocessing
function PP_Init_Effect(Mat)
{
	PP_Quad.material = Mat;
	PP_Quad.visible = on;
	StereoComb_mat.skin1 = bmap_createblack(screen_size.x,screen_size.y,24);
	camera.bmap = StereoComb_mat.skin1;
}

//the second view
view Stereo_view
{ 		
  layer = -1;
}

//function to activate the effect, EyeDist is the offset between the two views in quants
function PP_AddAnaglyph(EyeDist)
{
	//set the paramters for stereo view
	Stereo_view.size_x = screen_size.x;
	Stereo_view.size_y = screen_size.y;
	Stereo_view.arc = camera.arc;
	Stereo_view.visible = on;
	
	//let it render into StereoComb_mat.skin1
	StereoComb_mat.skin2 = bmap_createblack(screen_size.x,screen_size.y,24);
	Stereo_view.bmap = StereoComb_mat.skin2;
	
	PP_Init_Effect(StereoComb_mat);

	while(1)
	{
		//place the view next to camera, looking into the same direction
		Stereo_view.z = camera.z;
		Stereo_view.y = camera.y - EyeDist*cos(camera.pan);
		Stereo_view.x = camera.x + EyeDist*sin(camera.pan);
		vec_set(Stereo_view.pan,camera.pan);

		wait(1);
	}
}