//////////////////////////////////////////////////
/////////////////Stereo Anaglyphs/////////////////
//////////////////////////////////////////////////
//////////////////////////////////////////////////
////01.03.2008////////////////by Nils Daumann/////
/////////////slindev.wordpress.com////////////////
//////////////////////////////////////////////////


MATERIAL* StereoComb_mat=
{
	effect =
	"
		//Variables set by the engine:
		float4 vecViewPort;
		
		//Textures:
		texture TargetMap;
		texture mtlSkin1;
		
		//Sampler:
		sampler smpTarget = sampler_state { Texture = <TargetMap>; };
		sampler smpSkin1 = sampler_state { Texture = <mtlSkin1>; };

/////////////////////////////////////////////////////////
//		//Real Anaglyphs
//		float4x4 matView1ColTrans =
//		{
//			0.299,	0.587,	0.114,	0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
//		
//		float4x4 matView2ColTrans =
//		{
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.299,	0.587,	0.114,	0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
/////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////
//		//Grey Anaglyphs:
//		float4x4 matView1ColTrans =
//		{
//			0.299,	0.587,	0.114,	0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
//		
//		float4x4 matView2ColTrans =
//		{
//			0.0,		0.0,		0.0,		0.0,
//			0.299,	0.587,	0.114,	0.0,
//			0.299,	0.587,	0.114,	0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
/////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////
//		//Colored Anaglyphs:
//		float4x4 matView1ColTrans =
//		{
//			1.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
//		
//		float4x4 matView2ColTrans =
//		{
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		1.0,		0.0,		0.0,
//			0.0,		0.0,		1.0,		0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
/////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////
//		//Halfcolored Anaglyphs:
//		float4x4 matView1ColTrans =
//		{
//			0.299,	0.587,	0.114,	0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
//		
//		float4x4 matView2ColTrans =
//		{
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		1.0,		0.0,		0.0,
//			0.0,		0.0,		1.0,		0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
/////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////
		//Optimised Anaglyphs:
		float4x4 matView1ColTrans =
		{
			0.0,		0.7,		0.3,		0.0,
			0.0,		0.0,		0.0,		0.0,
			0.0,		0.0,		0.0,		0.0,
			0.0,		0.0,		0.0,		1.0
		};
		
		float4x4 matView2ColTrans =
		{
			0.0,		0.0,		0.0,		0.0,
			0.0,		1.0,		0.0,		0.0,
			0.0,		0.0,		1.0,		0.0,
			0.0,		0.0,		0.0,		1.0
		};
/////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////
//		//Amber-Blue Anaglyphs:
//		float4x4 matView1ColTrans =
//		{
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.299,	0.587,	0.114,	0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
//		
//		float4x4 matView2ColTrans =
//		{
//			1.0,		0.0,		0.0,		0.0,
//			0.0,		1.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
/////////////////////////////////////////////////////////

		
		float4 PixeShader(float2 TexCoords : TEXCOORD0) :COLOR
		{
			//Get the texturepixels colors
			float4 ColorView1 = tex2D(smpTarget,TexCoords);
			float4 ColorView2 = tex2D(smpSkin1,TexCoords);
			
			//calculate the resulting color
			float4 Color = mul(matView1ColTrans,ColorView1)+mul(matView2ColTrans,ColorView2);

			return Color;
		}
		
		technique PPE
		{
			pass p1
			{
				PixelShader = compile ps_1_4 PixeShader();
			}
		}
	";
}

//the second view
VIEW* Stereo_view =
{ 		
  layer = -1;
}

//function to activate the effect, EyeDist is the offset between the two views in quants
function PP_AddAnaglyph(EyeDist)
{
	//set the paramters for stereo view
	Stereo_view.size_x = screen_size.x;
	Stereo_view.size_y = screen_size.y;
	Stereo_view.arc = camera.arc;
	set(Stereo_view,VISIBLE);
	
	//let it render into StereoComb_mat.skin1
	StereoComb_mat.skin1 = bmap_createblack(screen_size.x,screen_size.y,24);
	Stereo_view.bmap = StereoComb_mat.skin1;
	
	//Add StereoComb_mat as a postprocessing effect to camera
	PP_Add(StereoComb_mat,camera,NULL);

	while(1)
	{
		//place the view next to camera, looking into the same direction
		Stereo_view.z = camera.z;
		Stereo_view.y = camera.y - EyeDist*cos(camera.pan);
		Stereo_view.x = camera.x + EyeDist*sin(camera.pan);
		vec_set(Stereo_view.pan,camera.pan);

		wait(1);
	}
}